
Redmine - Defect #16092

Parent/subtask: calculation of estimated hours

2014-02-13 15:35 - Pavel Potcheptsov

Status: Closed Start date:  

Priority: High Due date:  

Assignee:  % Done: 0%

Category: Time tracking Estimated time: 0.00 hour

Target version:    

Resolution: Fixed Affected version: 2.4.0

Description

We defined 1-level issue with estimated time 10 hours.

Once we defined subtask for 1-level issue with estimated time 15 hours, we got 15 hours in parent task. (should be 25 hours in

parent)

Once we defined subtask for above subtask with estimation 20 hours, above subtask became with 20 hours and parent task became

20 hours. (should be 45 in parent)

If we define another subtask for 1-level issue with estimation 30 hours, then parent task make sum of two subtasks on 2-level and

total time for parent task will be 50 hours. (should be 75 in parent)

But in general, with such arithmetic we're losing hours. Each task which has subtask should make a sum of it's own estimation hours

with all hours that defined in his subtasks, not round to hours in subtasks.

Related issues:

Related to Redmine - Feature #5490: Option for independent subtask priority/s... Closed 2010-05-10

Related to Redmine - Defect #17550: Spent time in exported CSV is wrong Closed

Related to Redmine - Feature #20688: Add Total estimated hours column on issu... Closed

Related to Redmine - Defect #21449: Automatic done ratio calculation in issue... New

Has duplicate Redmine - Feature #13775: Adding a sub-task with zero estimated... Closed

Associated revisions

Revision 14272 - 2015-05-25 13:37 - Jean-Philippe Lang

Don't store total estimated hours on parent issues (#16092).

Parent can now have its own estimate that is summed up with children estimates.

History

#1 - 2014-02-13 15:38 - Pavel Potcheptsov

I've made a typo in second sentence. Should be:

Once we defined subtask for 1-level issue with estimated time 15 hours, we got 15 hours in parent task. (should be 25 hours in parent)

#2 - 2014-02-22 11:16 - Toshi MARUYAMA

- Related to Feature #5490: Option for independent subtask priority/start date/due date/done ratio added

#3 - 2014-02-22 11:19 - Toshi MARUYAMA

- Description updated

#4 - 2014-02-22 11:29 - Toshi MARUYAMA

There are related posts.

Estimated time and subtasks

#5 - 2014-09-18 18:32 - Heiko Robert

I think I understood now how it works:

if a ticket becomes a parent task, estimated time on the parent ticket is replaced with the sum of all subtasks (old value of estimated time is lost!)

if the estimation for a subtask changes, the estimated hours of the master task is recalculated as sum of all subtasks

conclusion: the semantic of the time estimation field changes if the master_id is set - which is bad! This causes a semantic bug if estimated time is

shown in issue list view since time duplicates in master and subtickets.
https://www.redmine.org/boards/1/topics/41138


This inconsistency is continuing with spent time calculation which differs from detail to list view (#17550).

The concept is not very intuitive because it doesn't support / prevent a switch from a normal ticket to a master ticket without loosing time estimations.

It is a normal live cycle to start with a simple task/feature and to add bugs, missing features later as subtasks.

I think the solution would be not to use the estimated hours field as a sum field for master tickets. Instead sums should be saved (only) in the master

(if parent_id is not set) ticket in a separate field and/or solved by correct/dynamic sql and grouping. SQL/grouping should be handled in the time entry

report.

#6 - 2014-10-17 11:44 - Toshi MARUYAMA

- Related to Defect #17550: Spent time in exported CSV is wrong added

#7 - 2015-08-12 10:45 - Takashi Ichihashi

How can I get total estimate hours on parent issue via REST ? I had been able to get it  under version 3.0.

#8 - 2015-09-07 17:46 - Toshi MARUYAMA

- Related to Feature #20688: Add Total estimated hours column on issue list  added

#9 - 2015-09-07 17:47 - Toshi MARUYAMA

Takashi Ichihashi wrote:

How can I get total estimate hours on parent issue via REST ? I had been able to get it  under version 3.0.

 It is deleted (ref: #5490#note-93).

Please describe your opinion to #20688.

#10 - 2015-11-26 11:45 - Evgeny Popov

So, there is no any way to get total_estimate_hours via REST?

#11 - 2016-01-06 04:55 - Toshi MARUYAMA

- Related to Defect #21449: Automatic done ratio calculation in issue tree is wrong when parent has its own estimated time added

#12 - 2016-01-22 12:12 - Sebastian Paluch

Why this task is still open? It seems that r14272 implemented all what written in the description field, didn't it?

#13 - 2016-01-25 12:29 - Pavel Potcheptsov

- Status changed from New to Resolved

#14 - 2016-02-20 13:22 - Toshi MARUYAMA

- Status changed from Resolved to Closed

- Resolution set to Fixed

#15 - 2016-12-25 07:58 - Go MAEDA

- Has duplicate Feature #13775: Adding a sub-task with zero estimated time erases parents value added
